# bigip_config – Manage BIG-IP configuration sections

New in version 2.4.

- Synopsis

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Manages a BIG-IP configuration by allowing TMSH commands that modify running configuration, or merge SCF formatted files into the running configuration. Additionally, this module is of significant importance because it allows you to save your running configuration to disk. Since the F5 module only manipulate running configuration, it is important that you utilize this module to save that running config.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
merge_content string |  | Loads the specified configuration that you want to merge into the running configuration. This is equivalent to using the `tmsh` command `load sys config from-terminal merge`. If you need to read configuration from a file or template, use Ansible's `file` or `template` lookup plugins respectively.
provider dictionary added in 2.5 |  | A dict object containing connection details.
| auth_provider string |  | Configures the auth provider for to obtain authentication tokens from the remote device. This option is really used when working with BIG-IQ devices.
| password string / required |  | The password for the user account used to connect to the BIG-IP. You may omit this option by setting the environment variable `F5_PASSWORD`. aliases: pass, pwd
| server string / required |  | The BIG-IP host. You may omit this option by setting the environment variable `F5_SERVER`.
| server_port integer | Default: 443 | The BIG-IP server port. You may omit this option by setting the environment variable `F5_SERVER_PORT`.
| ssh_keyfile path |  | Specifies the SSH keyfile to use to authenticate the connection to the remote device. This argument is only used for cli transports. You may omit this option by setting the environment variable `ANSIBLE_NET_SSH_KEYFILE`.
| timeout integer |  | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.

transport
string

Choices:
- cli
- rest ←

Configures the transport connection to use when connecting to the remote device.

| user string / required |  | The username to connect to the BIG-IP with. This user must have administrative privileges on the device. You may omit this option by setting the environment variable `F5_USER`.

validate_certs
boolean

Choices:
- no
- yes ←

If `no`, SSL certificates are not validated. Use this only on personally controlled sites using self-signed certificates.
You may omit this option by setting the environment variable `F5_VALIDATE_CERTS`.

reset
boolean

Choices:
- no ←
- yes

Loads the default configuration on the device.
If this option is specified, the default configuration will be loaded before any commands or other provided configuration is run.

save
boolean

Choices:
- no
- yes ←

The `save` argument instructs the module to save the running-config to startup-config.
This operation is performed after any changes are made to the current running config. If no changes are made, the configuration is still saved to the startup config.
This option will always cause the module to return changed.

verify
boolean

Choices:
- no ←
- yes

Validates the specified configuration to see whether they are valid to replace the running configuration.
The running configuration will not be changed.
When this parameter is set to `yes`, no change will be reported by the module.

## Notes

Note

- For more information on using Ansible to manage F5 Networks devices see https://www.ansible.com/integrations/networks/f5.

- Requires BIG-IP software version >= 12.

- The F5 modules only manipulate the running configuration of the F5 product. To ensure that BIG-IP specific configuration persists to disk, be sure to include at least one task that uses the bigip_config module to save the running configuration. Refer to the module’s documentation for the correct usage of the module to save your running configuration.

## Examples

    - name: Save the running configuration of the BIG-IP
      bigip_config:
        save: yes
        provider:
          server: lb.mydomain.com
          password: secret
          user: admin
      delegate_to: localhost

    - name: Reset the BIG-IP configuration, for example, to RMA the device
      bigip_config:
        reset: yes
        save: yes
        provider:
          server: lb.mydomain.com
          password: secret
          user: admin
      delegate_to: localhost

    - name: Load an SCF configuration
      bigip_config:
        merge_content: "{{ lookup('file', '/path/to/config.scf') }}"
        provider:
          server: lb.mydomain.com
          password: secret
          user: admin
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
stdout list | always | The set of responses from the options Sample: ['...', '...']
stdout_lines list | always | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by an Ansible Partner. [certified]

### Authors

- Tim Rupp (@caphrim007)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.